<template>
    <div class="container">
        <MdDialog :md-active="true" class="dialog">
            <MdDialogTitle class="title">
                <span class="icon"><img src="@/assets/todo.png" /></span>
                <span class="text">{{$t('login.title')}}</span>
                <LanguageChooser class="language" />
            </MdDialogTitle>
            <MdDialogContent>
                <Editor
                        v-model="editorModel"
                        ref="editor"
                        :fields="[
                          {
                            label: this.$t('login.user'),
                            placeholder: this.$t('login.userPlaceholder'),
                            key: 'user',
                            required: true
                          },
                          {
                            label: this.$t('login.password'),
                            placeholder: this.$t('login.passwordPlaceholder'),
                            key: 'password',
                            type: 'password',
                            required: true
                          }
                        ]"
                />
            </MdDialogContent>
            <MdDialogActions>
                <MdButton @click="login(user, password)">{{$t('login.button')}}</MdButton>
            </MdDialogActions>
        </MdDialog>
    </div>
</template>
<script>
  import Vue from 'vue';
  import { login } from '../../Api';
  import { MdDialog, MdButton, MdField } from 'vue-material/dist/components';
  import LanguageChooser from '../LanguageChooser';
  import Editor from '../Editor';

  Vue.use(MdButton);
  Vue.use(MdField);
  Vue.use(MdDialog);

  export default {
    data() {
      return {
        fields: [
          {
            label: this.$t('login.user'),
            placeholder: this.$t('login.userPlaceholder'),
            key: 'user',
            required: true
          },
          {
            label: this.$t('login.password'),
            placeholder: this.$t('login.passwordPlaceholder'),
            key: 'password',
            type: 'password',
            required: true
          }
        ]
      }
    },
    computed: {
      editorModel: {
        get() {
          return this.$store.state.login;
        },
        set(model) {
          console.log('login model set', model);
          this.$store.dispatch('credentials', model);
        }
      },
      user: {
        get() {
          return this.$store.state.login.user;
        },
        set(user) {
          this.$store.dispatch('user', user);
        }
      },
      password: {
        get() {
          return this.$store.state.login.password;
        },
        set(password) {
          this.$store.dispatch('password', password);
        }
      }
    },
    methods: {
      async login(user, password) {
        // fields ok?
        const fieldsOk = this.$refs.editor.checkFields();
        if(!fieldsOk) return;

        // make login
        const { data: resp } = await login(user, btoa(password));

        // check result
        if (resp === 'ok') {
          // successfull -> go to /
          this.$router.push('/');
        } else {
          // failed -> show error bad credentials in editor
          this.$refs.editor.showError(this.$t('login.badCredentials'));
        }
      }
    },
    components: {
      LanguageChooser, Editor
    }
  };
</script>
<style scoped>
    .container {
        background-image: url('/images/background.jpg');
        background-size: cover;
    }

    .title {
        display: flex;
        align-items: center;
        flex-direction: row;
    }

    .text {
        flex: 1000 1px;
        margin-left: 20px;
    }

    .language {
        flex: 1 30px;
    }

    .icon {
        flex: 1 30px;
    }

    @media only screen and (max-width: 600px) {
        .dialog {
            max-width: 80%;
            max-height: 400px;
            margin: auto;
        }
    }
</style>
